<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>gluon: list/list.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">gluon
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_48c61abad44e2f181b0a6a33afb59c17.html">list</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">list.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="list_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#ifndef LIST_H</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#define LIST_H</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#ifndef LIST_TYPE</span></div><div class="line"><a name="l00010"></a><span class="lineno"><a class="line" href="list_8h.html#aa606355c30aa4b5f0ad83d25ed069b25">   10</a></span>&#160;<span class="preprocessor">#define LIST_TYPE uint32_t</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">//#define LIST_HEADER_ONLY</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifdef LIST_HEADER_ONLY</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define LIST_SPEC static inline</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00019"></a><span class="lineno"><a class="line" href="list_8h.html#a8d510b5a64febb5503672068127c17f4">   19</a></span>&#160;<span class="preprocessor">#define LIST_SPEC</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;stdint.h&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="structnode.html">   24</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structnode.html">node</a></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;{</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keyword">union </span>{</div><div class="line"><a name="l00027"></a><span class="lineno"><a class="line" href="structnode.html#a0e973e39fc867edc901786966850f5ca">   27</a></span>&#160;        <span class="keyword">struct </span><a class="code" href="structnode.html">node</a>* <a class="code" href="structnode.html#a0e973e39fc867edc901786966850f5ca">data_ptr</a>;</div><div class="line"><a name="l00028"></a><span class="lineno"><a class="line" href="structnode.html#a254df6efdfe9fb1cff5857ac6e50eeff">   28</a></span>&#160;        <a class="code" href="list_8h.html#aa606355c30aa4b5f0ad83d25ed069b25">LIST_TYPE</a> <a class="code" href="structnode.html#a254df6efdfe9fb1cff5857ac6e50eeff">data</a>;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    };</div><div class="line"><a name="l00030"></a><span class="lineno"><a class="line" href="structnode.html#a0dc1b6470487aa86d9936e3cab8b95be">   30</a></span>&#160;    <span class="keyword">struct </span><a class="code" href="structnode.html">node</a>* <a class="code" href="structnode.html#a0dc1b6470487aa86d9936e3cab8b95be">next</a>;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;};</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<a class="code" href="list_8h.html#a8d510b5a64febb5503672068127c17f4">LIST_SPEC</a> <span class="keyword">struct </span><a class="code" href="structnode.html">node</a>* <a class="code" href="list_8h.html#a3206ece3442f6c11aacdfaf67ec6410a">li_init</a>(<span class="keyword">struct</span> <a class="code" href="structnode.html">node</a>* memory, uint32_t length);</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<a class="code" href="list_8h.html#a8d510b5a64febb5503672068127c17f4">LIST_SPEC</a> <span class="keyword">struct </span><a class="code" href="structnode.html">node</a>* <a class="code" href="list_8h.html#a988318204cbf0f539ac987a337a28087">li_cons</a>(<span class="keyword">struct</span> <a class="code" href="structnode.html">node</a>* first, <span class="keyword">struct</span> <a class="code" href="structnode.html">node</a>* list);</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<a class="code" href="list_8h.html#a8d510b5a64febb5503672068127c17f4">LIST_SPEC</a> <span class="keyword">struct </span><a class="code" href="structnode.html">node</a>* <a class="code" href="list_8h.html#a8fc8db48323d87017e7f13b8d04b763e">li_first</a>(<span class="keyword">struct</span> <a class="code" href="structnode.html">node</a>* list);</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<a class="code" href="list_8h.html#a8d510b5a64febb5503672068127c17f4">LIST_SPEC</a> <span class="keyword">struct </span><a class="code" href="structnode.html">node</a>* <a class="code" href="list_8h.html#a83220df1c354534f7326563c657c6726">li_rest</a>(<span class="keyword">struct</span> <a class="code" href="structnode.html">node</a>* list);</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<a class="code" href="list_8h.html#a8d510b5a64febb5503672068127c17f4">LIST_SPEC</a> uint32_t <a class="code" href="list_8h.html#a54b830644dd7e5e2b697daae1f0e1d4e">li_length</a>(<span class="keyword">struct</span> <a class="code" href="structnode.html">node</a>* list);</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="preprocessor">#ifdef LIST_HEADER_ONLY</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="list_8c.html">list.c</a>&quot;</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="structnode_html_a0e973e39fc867edc901786966850f5ca"><div class="ttname"><a href="structnode.html#a0e973e39fc867edc901786966850f5ca">node::data_ptr</a></div><div class="ttdeci">struct node * data_ptr</div><div class="ttdef"><b>Definition:</b> list.h:27</div></div>
<div class="ttc" id="structnode_html"><div class="ttname"><a href="structnode.html">node</a></div><div class="ttdef"><b>Definition:</b> list.h:24</div></div>
<div class="ttc" id="list_8h_html_aa606355c30aa4b5f0ad83d25ed069b25"><div class="ttname"><a href="list_8h.html#aa606355c30aa4b5f0ad83d25ed069b25">LIST_TYPE</a></div><div class="ttdeci">#define LIST_TYPE</div><div class="ttdef"><b>Definition:</b> list.h:10</div></div>
<div class="ttc" id="list_8c_html"><div class="ttname"><a href="list_8c.html">list.c</a></div></div>
<div class="ttc" id="list_8h_html_a83220df1c354534f7326563c657c6726"><div class="ttname"><a href="list_8h.html#a83220df1c354534f7326563c657c6726">li_rest</a></div><div class="ttdeci">LIST_SPEC struct node * li_rest(struct node *list)</div><div class="ttdef"><b>Definition:</b> list.c:41</div></div>
<div class="ttc" id="list_8h_html_a3206ece3442f6c11aacdfaf67ec6410a"><div class="ttname"><a href="list_8h.html#a3206ece3442f6c11aacdfaf67ec6410a">li_init</a></div><div class="ttdeci">LIST_SPEC struct node * li_init(struct node *memory, uint32_t length)</div><div class="ttdef"><b>Definition:</b> list.c:8</div></div>
<div class="ttc" id="list_8h_html_a8fc8db48323d87017e7f13b8d04b763e"><div class="ttname"><a href="list_8h.html#a8fc8db48323d87017e7f13b8d04b763e">li_first</a></div><div class="ttdeci">LIST_SPEC struct node * li_first(struct node *list)</div><div class="ttdef"><b>Definition:</b> list.c:36</div></div>
<div class="ttc" id="list_8h_html_a8d510b5a64febb5503672068127c17f4"><div class="ttname"><a href="list_8h.html#a8d510b5a64febb5503672068127c17f4">LIST_SPEC</a></div><div class="ttdeci">#define LIST_SPEC</div><div class="ttdef"><b>Definition:</b> list.h:19</div></div>
<div class="ttc" id="list_8h_html_a988318204cbf0f539ac987a337a28087"><div class="ttname"><a href="list_8h.html#a988318204cbf0f539ac987a337a28087">li_cons</a></div><div class="ttdeci">LIST_SPEC struct node * li_cons(struct node *first, struct node *list)</div><div class="ttdef"><b>Definition:</b> list.c:28</div></div>
<div class="ttc" id="structnode_html_a0dc1b6470487aa86d9936e3cab8b95be"><div class="ttname"><a href="structnode.html#a0dc1b6470487aa86d9936e3cab8b95be">node::next</a></div><div class="ttdeci">struct node * next</div><div class="ttdef"><b>Definition:</b> list.h:30</div></div>
<div class="ttc" id="structnode_html_a254df6efdfe9fb1cff5857ac6e50eeff"><div class="ttname"><a href="structnode.html#a254df6efdfe9fb1cff5857ac6e50eeff">node::data</a></div><div class="ttdeci">LIST_TYPE data</div><div class="ttdef"><b>Definition:</b> list.h:28</div></div>
<div class="ttc" id="list_8h_html_a54b830644dd7e5e2b697daae1f0e1d4e"><div class="ttname"><a href="list_8h.html#a54b830644dd7e5e2b697daae1f0e1d4e">li_length</a></div><div class="ttdeci">LIST_SPEC uint32_t li_length(struct node *list)</div><div class="ttdef"><b>Definition:</b> list.c:46</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
